/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.invoicingfacade.exceptions.ClosedPaymentException;
import gz.cyberbrain.cyberhotel.model.invoicingfacade.exceptions.UnaceptablePaymentException;
import gz.cyberbrain.cyberhotel.model.invoicingfacade.spring.actions.ClosedCashException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashMap;

public class CashUpdater extends SaveAdapter {

	public Serializable save(HashMap map) {

		try {			

			if (inputTesting(map)) 

				CashController.updateCash((Long) map.get("cashNumber"), (Calendar) map.get("openDate"),
						(Calendar) map.get("closeDate"), (String) map.get("status"), (String) map.get("openUser"), 
						(String) map.get("closeUser"), (Collection) map.get("payments"), ((Boolean) map.get("closement")).booleanValue());			

		} catch (ClosedCashException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("closedCash"));
		} catch (UnaceptablePaymentException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("unaceptablePayment"));
		} catch (ClosedPaymentException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("closedPayment"));
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}	

		return (Long) map.get("cashNumber");

	}


	@Override
	protected boolean inputTesting(HashMap map) {
		ErrorsHandler.clear();
		return true;
	}

}
