/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.HashMap;

public class EmployeeCreator extends SaveAdapter {
	
	public Serializable save(HashMap map) {

		Serializable id = null;
		
		try {

			if (inputTesting(map))
				
			id = EmployeeController.createEmployee((Long) map.get("id"), (String) map.get("nif"), (String) map.get("name"), (String) map.get("firstSurname"), 
					(String) map.get("secondSurname"), (Calendar) map.get("bornDate"), (String) map.get("sex"), (String) map.get("maritalStatus"), (Long) map.get("address"), 
					(String) map.get("street"), (String) map.get("dwellingPlace"), (String) map.get("phone1"), (String) map.get("phone2"), (String) map.get("job"), 
					(Calendar) map.get("hireDate"), (BigDecimal) map.get("salary"), (String) map.get("observations"));

	
		} catch (InternalErrorException e) {			
			e.printStackTrace();
		} 
		return id;
	}

	protected boolean inputTesting(HashMap map) {
		
		if (((Long) map.get("address")) == null) {		
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));
			return false;
		}

		if (((String) map.get("name")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("name"));
			return false;
		}
		
		if (((String) map.get("firstSurname")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("firstSurname"));
			return false;
		}
		
		if (((String) map.get("secondSurname")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("secondSurname"));
			return false;
		}
			
		ErrorsHandler.clear();

		return true;

	}

}
