/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableBoardException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptablePriceTypeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAgencyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCompanyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableParticularException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptablePayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableRoomException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnavailableRoomException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InvalidIntervalException;

import java.io.Serializable;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Vector;

public class ReservationCreator extends SaveAdapter {
	
	public Serializable save(HashMap map, Vector vector) {

		Serializable id = null;
		
		try {

			if (inputTesting(map))

			id = ReservationController.createReservation((String) map.get("reservatorName"), (String) map.get("reservatorCif"), (String) map.get("reservatorAccount"), 
						(String) map.get("reservatorCard"), (String) map.get("reservatorPhone"), (String) map.get("reservationStatus"), (Calendar) map.get("incomingDate"), 
						(Calendar) map.get("expectedOutgoingDate"), (Calendar) map.get("trueOutgoingDate"), (Long) map.get("payer"), (Long) map.get("agency"), (Long) map.get("company"), 
						(String) map.get("notes"), ((Boolean) map.get("byHours")).booleanValue(), vector);

		} catch (UnaceptableParticularException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("particular"));
		} catch (UnaceptableBoardException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("board"));
		} catch (UnaceptablePriceTypeException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("priceType"));
		} catch (UnaceptableAgencyException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("agency"));
		} catch (UnaceptablePayerException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("payer"));
		} catch (UnaceptableRoomException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("roomUnaceptable"));
		} catch (UnavailableRoomException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("roomUnavailable"));
		} catch (UnaceptableCompanyException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("company"));
		} catch (InvalidIntervalException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("interval"));			
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}

		return id;
		
	}

	protected boolean inputTesting(HashMap map) {

		if (map.get("reservationStatus").equals("Rexistrada") || map.get("reservationStatus").equals("Finalizada")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("reservationStatus"));
			return false;
		}
		
		if ((((String) map.get("reservatorName")).trim()).equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("reservatorName"));
			return false;
		}

		ErrorsHandler.clear();

		return true;
	}	

}
