/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableRoomTypeException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;

public class RoomUpdater extends SaveAdapter {

	public Serializable save(HashMap map) {

		try {

			if (inputTesting(map))
				RoomController.updateRoom((String) map.get("code"), (String) map.get("number"), ((Long) map.get("floor")).longValue(), (String) map.get("type"), ((Boolean) map.get("smokers")).booleanValue(), ((Long) map.get("maxPax")).longValue(), (String) map.get("notes"));

		} catch (UnaceptableRoomTypeException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("type"));
		} catch (InstanceNotFoundException e) {	
			e.printStackTrace();
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}

		return (String) map.get("code");
		
	}

	protected boolean inputTesting(HashMap map) {

		if (((String) map.get("code")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("code"));
			return false;
		}

		if (((String) map.get("number")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("number"));
			return false;
		}

		ErrorsHandler.clear();

		return true;
	}


}
