/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.card.dao;

import gz.cyberbrain.cyberhotel.model.card.to.CardTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public class CardSpringDao extends AbstractSpringDao implements CardDao {

	public CardSpringDao() {
		super(CardTo.class);
	}	

	public CardTo create(CardTo cardTo) throws InternalErrorException {		

		return (CardTo) super.save(cardTo);

	}

	public CardTo find(Long cardId) throws InstanceNotFoundException, InternalErrorException {

		CardTo cardTo = (CardTo) super.find(cardId);
		return cardTo;

	}

	public void update(CardTo cardTo) throws InternalErrorException {		

		super.update(cardTo);

	}

	public void remove(CardTo cardTo) throws InternalErrorException {

			super.delete(cardTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allCards";
		return super.findByQuery(queryName);
		
	}
	
	public boolean existClients(Long cardId) throws InternalErrorException {
		String queryName = "cardClients";
		return (!super.findByAttribute(queryName, cardId).isEmpty());
	}
	
}
