/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.cash.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.money.MoneyOperations;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;

public class CashTo implements Identifiable {
	
	private static final long serialVersionUID = -6176451819799618377L;
	private Long cashNumber;
	private Calendar openDate;
	private Calendar closeDate;
	private long paymentsNumber;
	private long accountsNumber;
	private long cardsNumber;
	private long vouchersNumber;
	private BigDecimal accountsTotal;
	private BigDecimal cardsTotal;	
	private BigDecimal vouchersTotal;
	private BigDecimal cashTotal;
	private String status;
	private String openUser;
	private String closeUser;
	
	public CashTo(){}	

	public CashTo(Long cashNumber, Calendar openDate, Calendar closeDate, long paymentsNumber, long accountsNumber, long cardsNumber, long vouchersNumber, BigDecimal accountsTotal, BigDecimal cardsTotal, BigDecimal vouchersTotal, BigDecimal cashTotal, String status, String openUser, String closeUser) {
		this.cashNumber = cashNumber;
		this.openDate = openDate;
		this.closeDate = closeDate;
		this.paymentsNumber = paymentsNumber;
		this.accountsNumber = accountsNumber;
		this.cardsNumber = cardsNumber;
		this.vouchersNumber = vouchersNumber;
		this.accountsTotal = MoneyOperations.getDecimalReduction(accountsTotal);
		this.cardsTotal = MoneyOperations.getDecimalReduction(cardsTotal);
		this.vouchersTotal = MoneyOperations.getDecimalReduction(vouchersTotal);
		this.cashTotal = MoneyOperations.getDecimalReduction(cashTotal);
		this.status = status;
		this.openUser = openUser;
		this.closeUser = closeUser;
	}

	public Serializable getId(){
		return cashNumber;
	}

	public BigDecimal getAccountsTotal() {
		return accountsTotal;
	}

	public void setAccountsTotal(BigDecimal accountsTotal) {
		this.accountsTotal = accountsTotal;
	}

	public BigDecimal getCardsTotal() {
		return cardsTotal;
	}

	public void setCardsTotal(BigDecimal cardsTotal) {
		this.cardsTotal = cardsTotal;
	}

	public BigDecimal getCashTotal() {
		return cashTotal;
	}

	public void setCashTotal(BigDecimal cashTotal) {
		this.cashTotal = cashTotal;
	}

	public Calendar getCloseDate() {
		return closeDate;
	}

	public void setCloseDate(Calendar closeDate) {
		this.closeDate = closeDate;
	}

	public long getPaymentsNumber() {
		return paymentsNumber;
	}

	public void setPaymentsNumber(long paymentsNumber) {
		this.paymentsNumber = paymentsNumber;
	}

	public long getAccountsNumber() {
		return accountsNumber;
	}

	public void setAccountsNumber(long accountsNumber) {
		this.accountsNumber = accountsNumber;
	}

	public long getCardsNumber() {
		return cardsNumber;
	}

	public void setCardsNumber(long cardsNumber) {
		this.cardsNumber = cardsNumber;
	}

	public long getVouchersNumber() {
		return vouchersNumber;
	}

	public void setVouchersNumber(long vouchersNumber) {
		this.vouchersNumber = vouchersNumber;
	}

	public String getOpenUser() {
		return openUser;
	}

	public void setOpenUser(String openUser) {
		this.openUser = openUser;
	}

	public BigDecimal getVouchersTotal() {
		return vouchersTotal;
	}

	public void setVouchersTotal(BigDecimal vouchersTotal) {
		this.vouchersTotal = vouchersTotal;
	}

	public Long getCashNumber() {
		return cashNumber;
	}

	public void setCashNumber(Long cashNumber) {
		this.cashNumber = cashNumber;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public String getCloseUser() {
		return closeUser;
	}

	public void setCloseUser(String closeUser) {
		this.closeUser = closeUser;
	}

	public Calendar getOpenDate() {
		return openDate;
	}

	public void setOpenDate(Calendar openDate) {
		this.openDate = openDate;
	}		
	
}
