/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.client.dao;

import gz.cyberbrain.cyberhotel.model.client.to.ClientTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Vector;

public interface ClientDao {

	public ClientTo create(ClientTo clientTo) throws InternalErrorException;

	public ClientTo find(Long clientId) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (ClientTo clientTo) throws InternalErrorException;
	
	public void remove(ClientTo clientTo) throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findAllIds() throws InternalErrorException;
	
	public Collection findByKeys(Vector keys) throws InternalErrorException;
	
	public boolean existOwes(Long clientId) throws InternalErrorException;
	
	public boolean takesPartInReservation(Long clientId) throws InternalErrorException;
	
	public boolean existRequests(Long clientId) throws InternalErrorException;
	
	public boolean isPayer (Long clientId) throws InternalErrorException;
	
	public boolean existInvoices(Long clientId) throws InternalErrorException;
	
}
