/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeTariffiedException;
import gz.cyberbrain.cyberhotel.model.pricetype.dao.PriceTypeDao;
import gz.cyberbrain.cyberhotel.model.pricetype.to.PriceTypeTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeletePriceTypeAction {

	private PriceTypeTo priceTypeTo;
	private PriceTypeDao priceTypeDao;
	
	public DeletePriceTypeAction (PriceTypeTo priceTypeTo, PriceTypeDao priceTypeDao) {
		
		this.priceTypeTo = priceTypeTo;
		this.priceTypeDao = priceTypeDao;
		
	}
	
	public void execute() throws PriceTypeInUseException, PriceTypeTariffiedException, InternalErrorException {
		
		if (priceTypeDao.existRequests(priceTypeTo.getPriceTypeCode())) throw new PriceTypeInUseException(priceTypeTo);
		if (priceTypeDao.isTariffied(priceTypeTo.getPriceTypeCode())) throw new PriceTypeTariffiedException(priceTypeTo);
		
		priceTypeDao.remove(priceTypeTo);
		
	}
	
}
