/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.day.dao;

import gz.cyberbrain.cyberhotel.model.day.to.DayTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public class DaySpringDao extends AbstractSpringDao implements DayDao {

	public DaySpringDao() {
		super(DayTo.class);
	}	

	public DayTo create(DayTo dayTo) throws InternalErrorException {		

		return (DayTo) super.save(dayTo);

	}

	public DayTo find(Calendar dayDate) throws InstanceNotFoundException, InternalErrorException {

		DayTo dayTo = (DayTo) super.find(dayDate);
		return dayTo;

	}

	public void update(DayTo dayTo) throws InternalErrorException {		

		super.saveOrUpdate(dayTo);

	}

	public void remove(DayTo dayTo) throws InternalErrorException {

		super.delete(dayTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allDays";
		return super.findByQuery(queryName);

	}

	public Collection findBySeason(Long seasonId) throws InternalErrorException {
		String queryName = "seasonDays";
		return super.findByAttribute(queryName, seasonId);
	}

}
