/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.owe.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;

public class OweTo implements Identifiable {
	
	private static final long serialVersionUID = -4436268756913383278L;
	private Long oweNumber;
	private Calendar oweDate;
	private BigDecimal price;
	private BigDecimal vat;
	private BigDecimal amount;
	private BigDecimal discount;
	private String status;
	private Long particular;
	private String room;
	private Long invoiceNumber;
	private String invoiceSerial;
	private String concept;
	public OweTo(){}
	
	public OweTo(Long oweNumber, Calendar oweDate, BigDecimal price, BigDecimal vat, BigDecimal amount, BigDecimal discount, String status, Long particular, String room, Long invoiceNumber, String invoiceSerial, String concept) {		
		this.oweNumber = oweNumber;
		this.oweDate = oweDate;
		this.price = price;
		this.vat = vat;
		this.amount = amount;
		this.discount = discount;
		this.status = status;
		this.particular = particular;
		this.room = room;
		this.invoiceNumber = invoiceNumber;
		this.invoiceSerial = invoiceSerial;
		this.concept = concept;
	}
	
	public Serializable getId(){
		return oweNumber;
	}

	public BigDecimal getAmount() {
		return amount;
	}

	public void setAmount(BigDecimal amount) {
		this.amount = amount;
	}

	public String getConcept() {
		return concept;
	}

	public void setConcept(String concept) {
		this.concept = concept;
	}

	public BigDecimal getDiscount() {
		return discount;
	}

	public void setDiscount(BigDecimal discount) {
		this.discount = discount;
	}

	public Long getInvoiceNumber() {
		return invoiceNumber;
	}

	public void setInvoiceNumber(Long invoiceNumber) {
		this.invoiceNumber = invoiceNumber;
	}

	public String getInvoiceSerial() {
		return invoiceSerial;
	}

	public void setInvoiceSerial(String invoiceSerial) {
		this.invoiceSerial = invoiceSerial;
	}

	public Calendar getOweDate() {
		return oweDate;
	}

	public void setOweDate(Calendar oweDate) {
		this.oweDate = oweDate;
	}

	public Long getParticular() {
		return particular;
	}

	public void setParticular(Long particular) {
		this.particular = particular;
	}

	public BigDecimal getPrice() {
		return price;
	}

	public void setPrice(BigDecimal price) {
		this.price = price;
	}

	public String getRoom() {
		return room;
	}
	
	public void setRoom(String room) {
		this.room = room;
	}
	
	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}

	public BigDecimal getVat() {
		return vat;
	}

	public void setVat(BigDecimal vat) {
		this.vat = vat;
	}

	public Long getOweNumber() {
		return oweNumber;
	}

	public void setOweNumber(Long oweNumber) {
		this.oweNumber = oweNumber;
	}
	
}
