/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.reservation.dao;

import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public class ReservationSpringDao extends AbstractSpringDao implements ReservationDao {

	public ReservationSpringDao() {
		super(ReservationTo.class);
	}	

	public ReservationTo create(ReservationTo reservationTo) throws InternalErrorException {		

		return (ReservationTo) super.save(reservationTo);

	}

	public ReservationTo find(Long reservationId) throws InstanceNotFoundException, InternalErrorException {

		ReservationTo reservationTo = (ReservationTo) super.find(reservationId);
		return reservationTo;

	}

	public void update(ReservationTo reservationTo) throws InternalErrorException {		

		super.update(reservationTo);

	}

	public void remove(ReservationTo reservationTo) throws InternalErrorException {

			super.delete(reservationTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allReservations";
		return super.findByQuery(queryName);
		
	}
	
	public Collection findByStatus(String reservationStatus) throws InternalErrorException {
		
		String queryName = "reservationByStatus";
		return super.findByAttribute(queryName, reservationStatus);
		
	}
	
	public Collection findByDates(Calendar []attributes) throws InternalErrorException { 
		
		String queryName = "reservationByDates";
		return super.findByAttributes(queryName, attributes);
		
	}
	
	public Collection findRequests(Long reservationId) throws InternalErrorException {
		
		String queryName = "reservationRequests";
		return super.findByAttribute(queryName, reservationId);
		
	}

	public Collection findReservationOwes(Long reservationId) throws InternalErrorException {
		String queryName = "reservationOwes";
		Long []attributes = {reservationId, reservationId, reservationId};
		return super.findByAttributes(queryName, attributes);
	}

}
