/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.bank.dao.BankDao;
import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.CompanyTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class UpdateACompanyAction {
	
	private CompanyTo companyTo;
	private AddressDao addressDao;
	private BankDao bankDao;
	private ClientDao companyDao;
	
	public UpdateACompanyAction (CompanyTo companyTo, AddressDao addressDao, BankDao bankDao, ClientDao companyDao) {
		this.companyTo = companyTo;
		this.addressDao = addressDao;
		this.bankDao = bankDao;
		this.companyDao = companyDao;
	}
	
	public void execute() 
	throws UnaceptableAddressException, UnaceptableBankException, InternalErrorException {
				
		try {
			addressDao.find(companyTo.getAddress());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableAddressException(companyTo.getAddress());
		}
		
		try {
			bankDao.find(companyTo.getBank());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableBankException(companyTo.getBank());
		}
		
		//Companies don't use cards
		
		/*CardDao cardDao = SpringDaoFactory.getCardDao();
		
		try {
			cardDao.find(companyTo.getCard());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableCardException(companyTo.getCard());
		}*/
		
		companyDao.update(companyTo);
		
	}

}
