/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.model.spring.facade;

import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.invoicingfacade.delegate.InvoicingFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.reservationfacade.delegate.ReservationFacadeDelegate;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class SpringFacadeFactory {

private static ApplicationContext context;
	
	static {
		context = new ClassPathXmlApplicationContext("applicationContext.xml");
		}
	
	private SpringFacadeFactory(){}
	
	public static ConfigurationFacadeDelegate getConfigurationFacadeDelegate(){
		return (ConfigurationFacadeDelegate) context.getBean("configurationFacadeDelegate");
	}
	
	public static ReservationFacadeDelegate getReservationFacadeDelegate() {
		return (ReservationFacadeDelegate) context.getBean("reservationFacadeDelegate");
	}
	
	public static InvoicingFacadeDelegate getInvoicingFacadeDelegate() {
		return (InvoicingFacadeDelegate) context.getBean("invoicingFacadeDelegate");
	}
	
}
