/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.awt.FlowLayout;
import java.awt.Image;
import java.io.Serializable;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class ImageItem extends JPanel implements ListItem {

	private static final long serialVersionUID = 1L;
	private Serializable id;
	private String text;

	public ImageItem(Serializable id, String text, String imagePath) {

		this.id = id;
		this.text = text;
		setLayout(new FlowLayout(FlowLayout.LEFT));
		add(new JLabel(resizeImage(new ImageIcon(imagePath))));
		add(new JLabel(text));

	}

	public Serializable getId() {
		return id;
	}
	
	public String getText() {
		return text;
	}

	public void setId(Serializable id) {
		this.id = id;
	}

	public void setText(String text) {
		this.text = text;
	}

	private ImageIcon resizeImage(ImageIcon tmpIcon) {

		ImageIcon thumbnail = tmpIcon;

		if (tmpIcon.getIconHeight() > 50) {
			thumbnail = new ImageIcon(tmpIcon.getImage().
					getScaledInstance(70, 50,
							Image.SCALE_DEFAULT));
		}

		return thumbnail;
	}
	
	public String toString() {
		return text;
	}
	
}
