/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import java.awt.Color;
import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.JLabel;
import java.awt.Rectangle;

public class InfoPanel extends JPanel {

	private static final long serialVersionUID = 1L;

	private int height=50;	
	private JLabel imageLabel = null;
	private JLabel infoLabel = null;
	private String infoText = null;

	/**
	 * This is the default constructor
	 */
	public InfoPanel() {
		super();				
		initialize();		
	}
	
	public void setInfoText(String text) {
		infoText = text;
		infoLabel.setText(text);		
		infoLabel.setForeground(Color.BLACK);
	}
	
	public void setErrorText(String text) {
		infoText = text;
		infoLabel.setText(text);
		infoLabel.setForeground(Color.RED);
	}
	
	public String getInfoText() {
		return infoText;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		infoLabel = new JLabel();
		infoLabel.setBounds(new Rectangle(50, 0, 450, height));		
		imageLabel = new JLabel();
		imageLabel.setBounds(new Rectangle(0, 0, 50, height));		
		this.setSize(new Dimension(500, height));
		this.setBackground(Color.WHITE);
		this.setLayout(null);
		this.add(imageLabel, null);		
		this.add(infoLabel, null);
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
