/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package gz.cyberbrain.cyberhotel.view.swing.util.gui;

import javax.swing.text.*;
import java.awt.*;

public class IntegerDocument extends PlainDocument {
	
	private static final long serialVersionUID = 1L;
	int maxVal=0;
	public IntegerDocument(int maxLength) {
		maxVal = maxLength;
	}
	public void insertString(int offset, String str, AttributeSet a) throws BadLocationException {

		if (getLength() + str.length() > maxVal)
			return;
		else {
			try {
				if(!Double.isNaN(Double.parseDouble(str))) {
					super.insertString(offset, str, a);
				}
			} catch(Exception e) {				
				Toolkit.getDefaultToolkit().beep();
			}
		}
	}
}
