/************************************************************************************************/
/*                                                                                              */
/*      <cyberHotel: Gestion Hotelera GPL>                                                      */
/*      Copyright (C) <2008> <davide05@gmail.com>                                               */
/*                                                                                              */
/*      This program is free software: you can redistribute it and/or modify                    */
/*      it under the terms of the GNU General Public License as published by                    */
/*      the Free Software Foundation, either version 3 of the License, or                       */
/*      (at your option) any later version.                                                     */
/*                                                                                              */
/*      This program is distributed in the hope that it will be useful,                         */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of                          */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                    */ 
/*      See the GNU General Public License for more details.                                    */
/*                                                                                              */
/*      You should have received a copy of the GNU General Public License                       */
/*      along with this program.  If not, see <http://www.gnu.org/licenses/>.                   */
/*                                                                                              */
/************************************************************************************************/

package viewpatatera;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableRoomTypeException;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;
import java.util.List;

import controllerpatatero.RoomCreator;

public class RoomManager {

	public RoomManager(){}
	
	public static void main(String args[]) {
		
		String roomCode = "IN01";
		String number = "IN1";
		long floor = 1;
		String type = "IN";
		String occupancyStatus = "Libre";
		String cleaningStatus = "Limpa";
		Calendar checkingDate = Calendar.getInstance();
		boolean smokers = false;
		long maxPax = 1;
		String notes = "A primeira habitacin";
		Collection boarders = null;
		
		RoomCreator rc = new RoomCreator(roomCode, number,
				floor, type, occupancyStatus, cleaningStatus, checkingDate, smokers, maxPax, notes, boarders);
		
		try {
		
rc.createNewRoom();
			
		
			
			List bancos = (List) rc.showRooms();

			for (int i=0; i < bancos.size(); i++) {

				RoomTo banco = (RoomTo) bancos.get(i);

				System.out.println();
				System.out.println("id: " + banco.getId() + " Nome: " + banco.getRoomCode() + " Logo: " + banco.getType() + " No: " + banco.getNumber());

			}

			rc.deleteRoom();
		
		} catch (UnaceptableRoomTypeException e) {		
			e.printStackTrace();
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		
	}
	
}
